#import <objectbase.h>               //Agent is a SwarmObject
#import <objectbase/SwarmObject.h>
#import "World.h"

@class Interval;

@interface Agent:SwarmObject          
{
  @public
    Interval * demand;	/*" bid or -offer"*/ 
  Interval * profit;	/*" exp-weighted moving average "*/
  Interval * wealth;	/*" total agent wealth "*/
  Interval * position;	/*" total shares of stock "*/
  Interval * cash;	        /*" total agent cash position "*/ 
  Interval * initialcash;
  Interval * minholding;
  Interval * mincash;
  Interval * intrate;
  Interval * intratep1;
  Interval * price;         // price is maintained by World
  Interval * dividend;      // dividend is maintained by World
  int myID;
}

+createBegin: aZone;
+setWorld: (World *)aWorld;

-setID: (int)iD;
-setPosition: (Interval *)aDouble;
-setintrate: (Interval *)rate;
-setminHolding: (Interval *)holding   minCash: (Interval *)minimumcash;
-setInitialCash: (Interval *)initcash;
-setInitialHoldings;
-getPriceFromWorld;
-getDividendFromWorld;

-creditEarningsAndPayTaxes;
-(Interval *)constrainDemand: (Interval **)slope : (Interval *)trialprice;
-(Interval *)getAgentPosition;
-(double)getAgentPositionFDO;
-(Interval *)getWealth;
-(double)getWealthFDO;
-(Interval *)getCash;

-(void)drop;

//Methods specified by each agent type
-prepareForTrading;   
-(Interval *)getDemandAndSlope: (Interval **)slope forPrice: (Interval *)trialprce;
-updatePerformance;


@end





