// The Santa Fe Stockmarket -- Interface for the dividend process

#import <objectbase/SwarmObject.h>

@class Interval;

@interface Dividend: SwarmObject
{
 
  Interval *baseline; /*"The centerline around which deviations are computed.
		     //			This is equal to the mean for a symmetric process
		     //			(i.e., if asymmetry = 0).  "baseline" is set only
		     //			from the parameter file, and should NOT normally
		     //			be changed from the default value (10.0)."*/
  //

  Interval *amplitude; /*"The amplitude of the deviations from the baseline.
		      //			Measured in units of "baseline".  The standard
		      //			deviation of the process is proportional to this."*/

  int period;  /*"The period or auto-correlation time of the process."*/

  Interval *mindividend;  /*"floor under dividend values"*/
  Interval *maxdividend; /*"ceiling for dividend values"*/
  Interval *deviation;
  Interval *rho;
  Interval *gauss;
  Interval *dvdnd;
  id normal; /*"A Swarm Normal Generator object"*/
}

+createBegin: zone;
+create: zone;
- initNormal: (int)seed;

 //These member functions just take parameters set in the 
- setBaseline: (Interval *)theBaseline;
- setmindividend: (Interval *)minimumDividend;
- setmaxdividend: (Interval *)maximumDividend;
- (Interval *)setAmplitude: (Interval *)theAmplitude;
- (int)setPeriod: (int)thePeriod;
- setDerivedParamsFlattenRho: (BOOL)flatten_rho gauss: (BOOL)flatten_gauss;

- (Interval *)dividend;
-(void)drop;

@end




